# Introduction

Hyperdom is a simple, fast, feature rich framework for building dynamic browser applications.

Hyperdom supports:
 - a simple event-update-render cycle
 - promises for asynchronous operations
 - JSX
 - non-JSX
 - typescript
 - client-side routing
 - SVG
 - two-way data binding
 - server-side rendering

Hyperdom optimises for performance, developer usability and simplicity of application architecture.

Hyperdom is influenced by react and uses virtual-dom for the DOM patching. Unlike react though, there is no need for state management libraries (this problem simply does not exist in hyperdom), the API is compact and the routing is built in.

## Size

* `hyperdom.min.js`: 31K
* `hyperdom.min.js.gz`: 9.8K

## Browser Support

* IE 9, 10, 11
* Edge
* Safari
* Safari iOS
* Firefox
* Chrome

Other browsers are likely to work but aren't routinely tested.

## Sister Projects

* [hyperdom-ace-editor](https://github.com/featurist/hyperdom-ace-editor)
* [hyperdom-draggabilly](https://github.com/featurist/hyperdom-draggabilly)
* [hyperdom-medium-editor](https://github.com/featurist/hyperdom-medium-editor)
* [hyperdom-ckeditor](https://github.com/featurist/hyperdom-ckeditor)
* [hyperdom-semantic-ui](https://github.com/featurist/hyperdom-semantic-ui)
* [hyperdom-sortable](https://github.com/featurist/hyperdom-sortable)
* [hyperdom-zeroclipboard](https://github.com/featurist/hyperdom-zeroclipboard)
